# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_deb.configuration import Configuration


class DebRelease(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'repository': 'str',
        'codename': 'str',
        'suite': 'str',
        'distribution': 'str',
        'version': 'str',
        'origin': 'str',
        'label': 'str',
        'description': 'str'
    }

    attribute_map = {
        'repository': 'repository',
        'codename': 'codename',
        'suite': 'suite',
        'distribution': 'distribution',
        'version': 'version',
        'origin': 'origin',
        'label': 'label',
        'description': 'description'
    }

    def __init__(self, repository=None, codename=None, suite=None, distribution=None, version=None, origin=None, label=None, description=None, local_vars_configuration=None):  # noqa: E501
        """DebRelease - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._repository = None
        self._codename = None
        self._suite = None
        self._distribution = None
        self._version = None
        self._origin = None
        self._label = None
        self._description = None
        self.discriminator = None

        if repository is not None:
            self.repository = repository
        self.codename = codename
        self.suite = suite
        self.distribution = distribution
        self.version = version
        self.origin = origin
        self.label = label
        self.description = description

    @property
    def repository(self):
        """Gets the repository of this DebRelease.  # noqa: E501

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :return: The repository of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._repository

    @repository.setter
    def repository(self, repository):
        """Sets the repository of this DebRelease.

        A URI of a repository the new content unit should be associated with.  # noqa: E501

        :param repository: The repository of this DebRelease.  # noqa: E501
        :type: str
        """

        self._repository = repository

    @property
    def codename(self):
        """Gets the codename of this DebRelease.  # noqa: E501


        :return: The codename of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._codename

    @codename.setter
    def codename(self, codename):
        """Sets the codename of this DebRelease.


        :param codename: The codename of this DebRelease.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and codename is None:  # noqa: E501
            raise ValueError("Invalid value for `codename`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                codename is not None and len(codename) < 1):
            raise ValueError("Invalid value for `codename`, length must be greater than or equal to `1`")  # noqa: E501

        self._codename = codename

    @property
    def suite(self):
        """Gets the suite of this DebRelease.  # noqa: E501


        :return: The suite of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._suite

    @suite.setter
    def suite(self, suite):
        """Sets the suite of this DebRelease.


        :param suite: The suite of this DebRelease.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and suite is None:  # noqa: E501
            raise ValueError("Invalid value for `suite`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                suite is not None and len(suite) < 1):
            raise ValueError("Invalid value for `suite`, length must be greater than or equal to `1`")  # noqa: E501

        self._suite = suite

    @property
    def distribution(self):
        """Gets the distribution of this DebRelease.  # noqa: E501


        :return: The distribution of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this DebRelease.


        :param distribution: The distribution of this DebRelease.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and distribution is None:  # noqa: E501
            raise ValueError("Invalid value for `distribution`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                distribution is not None and len(distribution) < 1):
            raise ValueError("Invalid value for `distribution`, length must be greater than or equal to `1`")  # noqa: E501

        self._distribution = distribution

    @property
    def version(self):
        """Gets the version of this DebRelease.  # noqa: E501


        :return: The version of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DebRelease.


        :param version: The version of this DebRelease.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                version is not None and len(version) < 1):
            raise ValueError("Invalid value for `version`, length must be greater than or equal to `1`")  # noqa: E501

        self._version = version

    @property
    def origin(self):
        """Gets the origin of this DebRelease.  # noqa: E501


        :return: The origin of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._origin

    @origin.setter
    def origin(self, origin):
        """Sets the origin of this DebRelease.


        :param origin: The origin of this DebRelease.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                origin is not None and len(origin) < 1):
            raise ValueError("Invalid value for `origin`, length must be greater than or equal to `1`")  # noqa: E501

        self._origin = origin

    @property
    def label(self):
        """Gets the label of this DebRelease.  # noqa: E501


        :return: The label of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DebRelease.


        :param label: The label of this DebRelease.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                label is not None and len(label) < 1):
            raise ValueError("Invalid value for `label`, length must be greater than or equal to `1`")  # noqa: E501

        self._label = label

    @property
    def description(self):
        """Gets the description of this DebRelease.  # noqa: E501


        :return: The description of this DebRelease.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DebRelease.


        :param description: The description of this DebRelease.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 1):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `1`")  # noqa: E501

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebRelease):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DebRelease):
            return True

        return self.to_dict() != other.to_dict()
